#ifdef WIN32
#define _WIN32_WINNT 0x0501
#include <windows.h>
#include <stdio.h>
#endif

#include <sstream>
#include <iostream>

#include <fstream>

#include <conio.h>
#include <string.h>
#include <tchar.h>
#pragma hdrstop

#include <map>

#include <jsoncpp/json/json.h>

#define bzero(a) memset(a,0,sizeof(a)) //  

int console_max_size = 4096;							//  
std::map<std::string, std::string> console;

void show_help()
{
	std::cout << "**************************************\n";
	std::cout << "*     Welcome to GameAP Screen       *\n";
	std::cout << "**************************************\n\n";

	std::cout << "Program created by ET-NiK \n";
	std::cout << "Site: http://www.gameap.ru \n\n";

	std::cout << "Parameters\n";
	std::cout << "-t <type>	(start|get_console|send_command|kill)\n";
	std::cout << "-S <screen_name> name screen\n";
	std::cout << "-c <command>  command (example 'hlds.exe -game valve +ip 127.0.0.1 +port 27015 +map crossfire')\n\n";

	std::cout << "Examples:\n";
	std::cout << "screen.exe -t start -S hldm -c \"hlds.exe -game valve +ip 127.0.0.1 +port 27015 +map crossfire\"\n";
	std::cout << "screen.exe -t send_command -S hldm -c \"changelevel stalkyard\"\n";
	std::cout << "screen.exe -t get_console -S hldm \n";
	std::cout << "screen.exe -t kill -S hldm -c \n";
}

bool IsWinNT()  //   NT
{
	OSVERSIONINFO osv;
	osv.dwOSVersionInfoSize = sizeof(osv);
	GetVersionEx(&osv);
	return (osv.dwPlatformId == VER_PLATFORM_WIN32_NT);
}

void ErrorMessage(char *str)  //    
{
	LPVOID msg;

	FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		GetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), //   
		(LPTSTR) &msg,
		0,
		NULL
	);

	printf("%s: %s\n",str,msg);
	LocalFree(msg);
}

void console_append(std::string str_in, std::string name, int pid)
{
	int console_free = console_max_size-console[name].size();

	if (str_in.size() < console_free) {
		//    
		console[name].append(str_in);
	}
	else if (str_in.size() > console_free) {
		//  console[name],    
		int size_requred = str_in.size() - console_free;
		console[name] = console[name].substr(size_requred, console_max_size);
		console[name].append(str_in);
	}
	else if (str_in.size() > console_max_size) {
		//     console_max_size
		//   
		str_in = str_in.substr(str_in.size() - console_max_size, str_in.size());
		std::cout << "SIZE:" << str_in.size() << std::endl;
		console[name].append(str_in);
	}

	std::ofstream fout(".db/" + name + ".json", std::ios_base::out);

	Json::Value jwrite;
	jwrite["pid"]		= pid;
	jwrite["console"]	= console[name];
	jwrite["command"]	= "";

	fout << jwrite;
	fout.close();
}

void run(std::string command, std::string sname)
{
	char buf[1024];           // /

	STARTUPINFO si;
	SECURITY_ATTRIBUTES sa;
	SECURITY_DESCRIPTOR sd;        // security  
	PROCESS_INFORMATION pi;

	HANDLE newstdin, newstdout, read_stdout, write_stdin;  // 

	if (IsWinNT()) {
		// security  Windows NT
		InitializeSecurityDescriptor(&sd, SECURITY_DESCRIPTOR_REVISION);
		SetSecurityDescriptorDacl(&sd, true, NULL, false);
		sa.lpSecurityDescriptor = &sd;
	}
	else {
		sa.lpSecurityDescriptor = NULL;
	}

	sa.nLength = sizeof(SECURITY_ATTRIBUTES);
	sa.bInheritHandle = true;       //  


	if (!CreatePipe(&newstdin, &write_stdin, &sa, 0)) {
		//    stdin
		ErrorMessage("CreatePipe");
		_getch();
		return;
	}

	if (!CreatePipe(&read_stdout, &newstdout, &sa, 0)) {
		//    stdout
		ErrorMessage("CreatePipe");
		_getch();
		CloseHandle(newstdin);
		CloseHandle(write_stdin);
		return;
	}

	GetStartupInfo(&si);	// startupinfo   

	/*

	 dwFlags   CreateProcess
	    .

	STARTF_USESTDHANDLES   hStd*.
	STARTF_USESHOWWINDOW   wShowWindow.

	*/

	si.dwFlags = STARTF_USESTDHANDLES | STARTF_USESHOWWINDOW;
	si.wShowWindow = SW_HIDE;
	si.hStdOutput = newstdout;
	si.hStdError = newstdout;   //  
	si.hStdInput = newstdin;    //  

	//const size_t cSize = strlen(command.c_str()) + 1;
	wchar_t* szCmdline = new wchar_t[strlen(command.c_str()) + 1];
	mbstowcs(szCmdline, command.c_str(), strlen(command.c_str()) + 1);

//	LPTSTR szCmdline = wc;

	//LPTSTR szCmdline = _tcsdup(TEXT("C:\\windows\\system32\\cmd.exe"));

	//  

	if (!CreateProcess(NULL, szCmdline, NULL, NULL, TRUE, CREATE_NEW_CONSOLE, NULL, NULL, &si, &pi)) {
		ErrorMessage("CreateProcess");
		_getch();
		CloseHandle(newstdin);
		CloseHandle(newstdout);
		CloseHandle(read_stdout);
		CloseHandle(write_stdin);
		exit(0);
	}

	// std::cout << "Process started with pid=" << pi.dwProcessId << std::endl;

	unsigned long exit = 0;  //  
	unsigned long bread;   //-  
	unsigned long avail;   //-  

	bzero(buf);

	Json::Value jroot;	// Read
	Json::Reader jreader(Json::Features::strictMode());

	std::fstream fin;
	std::string json_in;

	for (;;)      //  
	{
		Sleep(1000);
		GetExitCodeProcess(pi.hProcess, &exit); //    
		if (exit != STILL_ACTIVE)
			break;

		fin.open(".db/" + sname + ".json");

		json_in = "";

		if (fin) {
			for (std::string line; std::getline(fin, line); json_in = json_in + line);
			jreader.parse(json_in, jroot, false);
			fin.close();
			//std::cout << "FILE: " << json_in << std::endl;
		}

		PeekNamedPipe(read_stdout, buf, 1023, &bread, &avail, NULL);

		//,       stdout
		if (bread != 0) {
			bzero(buf);

			if (avail > 1023) {
				while (bread >= 1023)
				{
					ReadFile(read_stdout, buf, 1023, &bread, NULL);  //   stdout
					//printf("%s",buf);
					console_append((const char*)buf, sname, pi.dwProcessId);
					bzero(buf);
				}
			}
			else {
				ReadFile(read_stdout, buf, 1023, &bread, NULL);
				console_append((const char*)buf, sname, pi.dwProcessId);
				//printf("%s",buf);
			}
		}

		if (jroot["command"].asString() != "") {
			bzero(buf);

			std::string send_command = jroot["command"].asString();

			int i = 0;
			while (i < send_command.size()) {
				*buf = (char)send_command[i];

				WriteFile(write_stdin, buf, 1, &bread, NULL);
				i++;
			}

			*buf = '\n';
			WriteFile(write_stdin, buf, 1, &bread, NULL);

			console_append("", sname, pi.dwProcessId);
		}
	}

	std::string file_name = ".db/" + sname + ".json";
	remove(&file_name[0]);

	CloseHandle(pi.hThread);
	CloseHandle(pi.hProcess);
	CloseHandle(newstdin);
	CloseHandle(newstdout);
	CloseHandle(read_stdout);
	CloseHandle(write_stdin);
}


//----------------------------------------------------------------------

void main(int argc, char* argv[])
{
	std::string type		= "";
	std::string command		= "";
	std::string sname		= "";

	for (int i = 0; i < argc - 1; i++) {
		if (std::string(argv[i]) == "-t") {
			// 
			type = argv[i + 1];
			i++;
		}
		else if (std::string(argv[i]) == "-S") {
			// 
			sname = argv[i + 1];
			i++;
		}
		else if (std::string(argv[i]) == "-c") {
			// 
			command = argv[i + 1];
			i++;
		}
		else {
			// ...
		}
	}

	if (type == "start") {
		//  

		if (command == "") {
			std::cout << "Empty command" << std::endl;
			exit(0);
		}

		if (sname == "") {
			std::cout << "Empty screen name" << std::endl;
			exit(0);
		}

		run(command, sname);
	}
	else if (type == "get_console") {
		//  

		if (sname == "") {
			std::cout << "Empty screen name" << std::endl;
			exit(0);
		}

		std::fstream fin;
		fin.open(".db/" + sname + ".json");

		Json::Value jroot;	// Read
		Json::Reader jreader(Json::Features::strictMode());

		std::string json_in;

		if (fin) {
			for (std::string line; std::getline(fin, line); json_in = json_in + line);
			jreader.parse(json_in, jroot, false);
			fin.close();
		}

		std::cout << jroot["console"].asString() << std::endl;

	}
	else if (type == "send_command") {
		//  

		if (command == "") {
			std::cout << "Empty command" << std::endl;
			exit(0);
		}

		if (sname == "") {
			std::cout << "Empty screen name" << std::endl;
			exit(0);
		}

		//  json
		std::fstream fin(".db/" + sname + ".json");
		//fin.open(".db/" + sname + ".json");

		Json::Value jroot;	// Read
		Json::Reader jreader(Json::Features::strictMode());

		std::string json_in;

		if (fin) {
			for (std::string line; std::getline(fin, line); json_in = json_in + line);
			jreader.parse(json_in, jroot, false);
			fin.close();
		}

		if (jroot["pid"].asString() == "") {
			std::cout << "Unknown screen name" << std::endl;
			exit(0);
		}

		//  json
		std::ofstream fout(".db/" + sname + ".json", std::ios_base::out);

		Json::Value jwrite;
		jroot["command"] = command;

		fout << jroot;
		fout.close();
	}
	else if (type == "kill") {
		//  

		if (sname == "") {
			std::cout << "Empty screen name" << std::endl;
			exit(0);
		}

		std::fstream fin;
		fin.open(".db/" + sname + ".json");

		Json::Value jroot;	// Read
		Json::Reader jreader(Json::Features::strictMode());

		std::string json_in;

		if (fin) {
			for (std::string line; std::getline(fin, line); json_in = json_in + line);
			jreader.parse(json_in, jroot, false);
			fin.close();
		}

		if (jroot["pid"].asString() != "") {

			std::string cmd_kill_str = "taskkill /PID " + jroot["pid"].asString();
			wchar_t* cmd_kill = new wchar_t[strlen(cmd_kill_str.c_str()) + 1];
			mbstowcs(cmd_kill, cmd_kill_str.c_str(), strlen(cmd_kill_str.c_str()) + 1);

			::_tsystem(cmd_kill);

			/*
			std::string file_name = ".db/" + sname + ".json";
			remove(&file_name[0]);
			*/
			
		}
		else {
			std::cout << "Unknown screen name" << std::endl;
		}

	}
	else {
		show_help();
	}
}

//----------------------------EOF-----------------------------------
//------------------------------------------------------------------